<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:49 JST 2014 -->
<TITLE>
ZKDatabase
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ZKDatabase";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/WatchManager.html" title="class in org.apache.zookeeper.server"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/ZooKeeperSaslServer.html" title="class in org.apache.zookeeper.server"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?org/apache/zookeeper/server/ZKDatabase.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ZKDatabase.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper.server</FONT>
<BR>
Class ZKDatabase</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.server.ZKDatabase</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <B>ZKDatabase</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
This class maintains the in memory database of zookeeper
 server states that includes the sessions, datatree and the
 committed logs. It is booted up  after reading the logs
 and snapshots from the disk.
<P>

<P>
<HR>

<P>
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#commitLogBuffer">commitLogBuffer</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#commitLogCount">commitLogCount</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;java.util.LinkedList&lt;<A HREF="../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#committedLog">committedLog</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../org/apache/zookeeper/server/DataTree.html" title="class in org.apache.zookeeper.server">DataTree</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#dataTree">dataTree</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;make sure on a clear you take care of 
 all these members.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;java.util.concurrent.locks.ReentrantReadWriteLock</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#logLock">logLock</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#maxCommittedLog">maxCommittedLog</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#minCommittedLog">minCommittedLog</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;java.util.concurrent.ConcurrentHashMap&lt;java.lang.Long,java.lang.Integer&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#sessionsWithTimeouts">sessionsWithTimeouts</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;org.apache.zookeeper.server.persistence.FileTxnSnapLog</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#snapLog">snapLog</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#ZKDatabase(org.apache.zookeeper.server.persistence.FileTxnSnapLog)">ZKDatabase</A></B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;snapLog)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the filetxnsnaplog that this zk database
 maps to.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#addCommittedProposal(org.apache.zookeeper.server.Request)">addCommittedProposal</A></B>(<A HREF="../../../../org/apache/zookeeper/server/Request.html" title="class in org.apache.zookeeper.server">Request</A>&nbsp;request)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;maintains a list of last <i>committedLog</i>
  or so committed requests.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#append(org.apache.zookeeper.server.Request)">append</A></B>(<A HREF="../../../../org/apache/zookeeper/server/Request.html" title="class in org.apache.zookeeper.server">Request</A>&nbsp;si)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;append to the underlying transaction log</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#clear()">clear</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;clear the zkdatabase.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#close()">close</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;close this database.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#commit()">commit</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;commit to the underlying transaction log</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;ACL&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#convertLong(java.lang.Long)">convertLong</A></B>(java.lang.Long&nbsp;aclL)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;convert from long to the acl entry</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#deserializeSnapshot(org.apache.jute.InputArchive)">deserializeSnapshot</A></B>(org.apache.jute.InputArchive&nbsp;ia)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;deserialize a snapshot from an input archive</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#dumpEphemerals(java.io.PrintWriter)">dumpEphemerals</A></B>(java.io.PrintWriter&nbsp;pwriter)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;write a text dump of all the ephemerals in the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;ACL&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getACL(java.lang.String, Stat)">getACL</A></B>(java.lang.String&nbsp;path,
       Stat&nbsp;stat)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get acl for a path</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getAclSize()">getAclSize</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get the acl size of the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.List&lt;java.lang.String&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getChildren(java.lang.String, Stat, org.apache.zookeeper.Watcher)">getChildren</A></B>(java.lang.String&nbsp;path,
            Stat&nbsp;stat,
            <A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get children list for this path</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.LinkedList&lt;<A HREF="../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getCommittedLog()">getCommittedLog</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;byte[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getData(java.lang.String, Stat, org.apache.zookeeper.Watcher)">getData</A></B>(java.lang.String&nbsp;path,
        Stat&nbsp;stat,
        <A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get data and stat for a path</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../org/apache/zookeeper/server/DataTree.html" title="class in org.apache.zookeeper.server">DataTree</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getDataTree()">getDataTree</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the datatree for this zkdatabase</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getDataTreeLastProcessedZxid()">getDataTreeLastProcessedZxid</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get the last processed zxid from a datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.HashSet&lt;java.lang.String&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getEphemerals(long)">getEphemerals</A></B>(long&nbsp;sessionId)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the paths for  ephemeral session id</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.concurrent.locks.ReentrantReadWriteLock</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getLogLock()">getLogLock</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Get the lock that controls the committedLog.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getmaxCommittedLog()">getmaxCommittedLog</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the committed log for this zk database</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getminCommittedLog()">getminCommittedLog</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the minimum committed transaction log
 available in memory</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../org/apache/zookeeper/server/DataNode.html" title="class in org.apache.zookeeper.server">DataNode</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getNode(java.lang.String)">getNode</A></B>(java.lang.String&nbsp;path)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get the datanode for this path</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getNodeCount()">getNodeCount</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the node count of the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Collection&lt;java.lang.Long&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getSessions()">getSessions</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return the sessions in the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.concurrent.ConcurrentHashMap&lt;java.lang.Long,java.lang.Integer&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#getSessionWithTimeOuts()">getSessionWithTimeOuts</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get sessions with timeouts</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#isInitialized()">isInitialized</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;checks to see if the zk database has been
 initialized or not.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#isSpecialPath(java.lang.String)">isSpecialPath</A></B>(java.lang.String&nbsp;path)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;check if the path is special or not</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#killSession(long, long)">killSession</A></B>(long&nbsp;sessionId,
            long&nbsp;zxid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;kill a given session in the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#loadDataBase()">loadDataBase</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;load the database from the disk onto memory and also add 
 the transactions to the committedlog in memory.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../org/apache/zookeeper/server/DataTree.ProcessTxnResult.html" title="class in org.apache.zookeeper.server">DataTree.ProcessTxnResult</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#processTxn(TxnHeader, org.apache.jute.Record)">processTxn</A></B>(TxnHeader&nbsp;hdr,
           org.apache.jute.Record&nbsp;txn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the process txn on the data</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#removeCnxn(org.apache.zookeeper.server.ServerCnxn)">removeCnxn</A></B>(<A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A>&nbsp;cnxn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;remove a cnxn from the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#rollLog()">rollLog</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;roll the underlying log</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#serializeSnapshot(org.apache.jute.OutputArchive)">serializeSnapshot</A></B>(org.apache.jute.OutputArchive&nbsp;oa)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;serialize the snapshot</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#setDataTreeInit(boolean)">setDataTreeInit</A></B>(boolean&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;set the datatree initialized or not</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#setlastProcessedZxid(long)">setlastProcessedZxid</A></B>(long&nbsp;zxid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the last processed zxid in the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#setWatches(long, java.util.List, java.util.List, java.util.List, org.apache.zookeeper.Watcher)">setWatches</A></B>(long&nbsp;relativeZxid,
           java.util.List&lt;java.lang.String&gt;&nbsp;dataWatches,
           java.util.List&lt;java.lang.String&gt;&nbsp;existWatches,
           java.util.List&lt;java.lang.String&gt;&nbsp;childWatches,
           <A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;set watches on the datatree</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;Stat</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#statNode(java.lang.String, org.apache.zookeeper.server.ServerCnxn)">statNode</A></B>(java.lang.String&nbsp;path,
         <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A>&nbsp;serverCnxn)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;stat the path</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/ZKDatabase.html#truncateLog(long)">truncateLog</A></B>(long&nbsp;zxid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Truncate the ZKDatabase to the specified zxid</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="dataTree"><!-- --></A><H3>
dataTree</H3>
<PRE>
protected <A HREF="../../../../org/apache/zookeeper/server/DataTree.html" title="class in org.apache.zookeeper.server">DataTree</A> <B>dataTree</B></PRE>
<DL>
<DD>make sure on a clear you take care of 
 all these members.
<P>
<DL>
</DL>
</DL>
<HR>

<A NAME="sessionsWithTimeouts"><!-- --></A><H3>
sessionsWithTimeouts</H3>
<PRE>
protected java.util.concurrent.ConcurrentHashMap&lt;java.lang.Long,java.lang.Integer&gt; <B>sessionsWithTimeouts</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="snapLog"><!-- --></A><H3>
snapLog</H3>
<PRE>
protected org.apache.zookeeper.server.persistence.FileTxnSnapLog <B>snapLog</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="minCommittedLog"><!-- --></A><H3>
minCommittedLog</H3>
<PRE>
protected long <B>minCommittedLog</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="maxCommittedLog"><!-- --></A><H3>
maxCommittedLog</H3>
<PRE>
protected long <B>maxCommittedLog</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="commitLogCount"><!-- --></A><H3>
commitLogCount</H3>
<PRE>
public static final int <B>commitLogCount</B></PRE>
<DL>
<DL>
<DT><B>See Also:</B><DD><A HREF="../../../../constant-values.html#org.apache.zookeeper.server.ZKDatabase.commitLogCount">Constant Field Values</A></DL>
</DL>
<HR>

<A NAME="commitLogBuffer"><!-- --></A><H3>
commitLogBuffer</H3>
<PRE>
protected static int <B>commitLogBuffer</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="committedLog"><!-- --></A><H3>
committedLog</H3>
<PRE>
protected java.util.LinkedList&lt;<A HREF="../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A>&gt; <B>committedLog</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="logLock"><!-- --></A><H3>
logLock</H3>
<PRE>
protected java.util.concurrent.locks.ReentrantReadWriteLock <B>logLock</B></PRE>
<DL>
<DL>
</DL>
</DL>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="ZKDatabase(org.apache.zookeeper.server.persistence.FileTxnSnapLog)"><!-- --></A><H3>
ZKDatabase</H3>
<PRE>
public <B>ZKDatabase</B>(org.apache.zookeeper.server.persistence.FileTxnSnapLog&nbsp;snapLog)</PRE>
<DL>
<DD>the filetxnsnaplog that this zk database
 maps to. There is a one to one relationship
 between a filetxnsnaplog and zkdatabase.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>snapLog</CODE> - the FileTxnSnapLog mapping this zkdatabase</DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="isInitialized()"><!-- --></A><H3>
isInitialized</H3>
<PRE>
public boolean <B>isInitialized</B>()</PRE>
<DL>
<DD>checks to see if the zk database has been
 initialized or not.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>true if zk database is initialized and false if not</DL>
</DD>
</DL>
<HR>

<A NAME="clear()"><!-- --></A><H3>
clear</H3>
<PRE>
public void <B>clear</B>()</PRE>
<DL>
<DD>clear the zkdatabase. 
 Note to developers - be careful to see that 
 the clear method does clear out all the
 data structures in zkdatabase.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getDataTree()"><!-- --></A><H3>
getDataTree</H3>
<PRE>
public <A HREF="../../../../org/apache/zookeeper/server/DataTree.html" title="class in org.apache.zookeeper.server">DataTree</A> <B>getDataTree</B>()</PRE>
<DL>
<DD>the datatree for this zkdatabase
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the datatree for this zkdatabase</DL>
</DD>
</DL>
<HR>

<A NAME="getmaxCommittedLog()"><!-- --></A><H3>
getmaxCommittedLog</H3>
<PRE>
public long <B>getmaxCommittedLog</B>()</PRE>
<DL>
<DD>the committed log for this zk database
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the committed log for this zkdatabase</DL>
</DD>
</DL>
<HR>

<A NAME="getminCommittedLog()"><!-- --></A><H3>
getminCommittedLog</H3>
<PRE>
public long <B>getminCommittedLog</B>()</PRE>
<DL>
<DD>the minimum committed transaction log
 available in memory
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the minimum committed transaction
 log available in memory</DL>
</DD>
</DL>
<HR>

<A NAME="getLogLock()"><!-- --></A><H3>
getLogLock</H3>
<PRE>
public java.util.concurrent.locks.ReentrantReadWriteLock <B>getLogLock</B>()</PRE>
<DL>
<DD>Get the lock that controls the committedLog. If you want to get the pointer to the committedLog, you need
 to use this lock to acquire a read lock before calling getCommittedLog()
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the lock that controls the committed log</DL>
</DD>
</DL>
<HR>

<A NAME="getCommittedLog()"><!-- --></A><H3>
getCommittedLog</H3>
<PRE>
public java.util.LinkedList&lt;<A HREF="../../../../org/apache/zookeeper/server/quorum/Leader.Proposal.html" title="class in org.apache.zookeeper.server.quorum">Leader.Proposal</A>&gt; <B>getCommittedLog</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getDataTreeLastProcessedZxid()"><!-- --></A><H3>
getDataTreeLastProcessedZxid</H3>
<PRE>
public long <B>getDataTreeLastProcessedZxid</B>()</PRE>
<DL>
<DD>get the last processed zxid from a datatree
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the last processed zxid of a datatree</DL>
</DD>
</DL>
<HR>

<A NAME="setDataTreeInit(boolean)"><!-- --></A><H3>
setDataTreeInit</H3>
<PRE>
public void <B>setDataTreeInit</B>(boolean&nbsp;b)</PRE>
<DL>
<DD>set the datatree initialized or not
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>b</CODE> - set the datatree initialized to b</DL>
</DD>
</DL>
<HR>

<A NAME="getSessions()"><!-- --></A><H3>
getSessions</H3>
<PRE>
public java.util.Collection&lt;java.lang.Long&gt; <B>getSessions</B>()</PRE>
<DL>
<DD>return the sessions in the datatree
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the data tree sessions</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionWithTimeOuts()"><!-- --></A><H3>
getSessionWithTimeOuts</H3>
<PRE>
public java.util.concurrent.ConcurrentHashMap&lt;java.lang.Long,java.lang.Integer&gt; <B>getSessionWithTimeOuts</B>()</PRE>
<DL>
<DD>get sessions with timeouts
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the hashmap of sessions with timeouts</DL>
</DD>
</DL>
<HR>

<A NAME="loadDataBase()"><!-- --></A><H3>
loadDataBase</H3>
<PRE>
public long <B>loadDataBase</B>()
                  throws java.io.IOException</PRE>
<DL>
<DD>load the database from the disk onto memory and also add 
 the transactions to the committedlog in memory.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the last valid zxid on disk
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="addCommittedProposal(org.apache.zookeeper.server.Request)"><!-- --></A><H3>
addCommittedProposal</H3>
<PRE>
public void <B>addCommittedProposal</B>(<A HREF="../../../../org/apache/zookeeper/server/Request.html" title="class in org.apache.zookeeper.server">Request</A>&nbsp;request)</PRE>
<DL>
<DD>maintains a list of last <i>committedLog</i>
  or so committed requests. This is used for
 fast follower synchronization.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>request</CODE> - committed request</DL>
</DD>
</DL>
<HR>

<A NAME="removeCnxn(org.apache.zookeeper.server.ServerCnxn)"><!-- --></A><H3>
removeCnxn</H3>
<PRE>
public void <B>removeCnxn</B>(<A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A>&nbsp;cnxn)</PRE>
<DL>
<DD>remove a cnxn from the datatree
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>cnxn</CODE> - the cnxn to remove from the datatree</DL>
</DD>
</DL>
<HR>

<A NAME="killSession(long, long)"><!-- --></A><H3>
killSession</H3>
<PRE>
public void <B>killSession</B>(long&nbsp;sessionId,
                        long&nbsp;zxid)</PRE>
<DL>
<DD>kill a given session in the datatree
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>sessionId</CODE> - the session id to be killed<DD><CODE>zxid</CODE> - the zxid of kill session transaction</DL>
</DD>
</DL>
<HR>

<A NAME="dumpEphemerals(java.io.PrintWriter)"><!-- --></A><H3>
dumpEphemerals</H3>
<PRE>
public void <B>dumpEphemerals</B>(java.io.PrintWriter&nbsp;pwriter)</PRE>
<DL>
<DD>write a text dump of all the ephemerals in the datatree
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>pwriter</CODE> - the output to write to</DL>
</DD>
</DL>
<HR>

<A NAME="getNodeCount()"><!-- --></A><H3>
getNodeCount</H3>
<PRE>
public int <B>getNodeCount</B>()</PRE>
<DL>
<DD>the node count of the datatree
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the node count of datatree</DL>
</DD>
</DL>
<HR>

<A NAME="getEphemerals(long)"><!-- --></A><H3>
getEphemerals</H3>
<PRE>
public java.util.HashSet&lt;java.lang.String&gt; <B>getEphemerals</B>(long&nbsp;sessionId)</PRE>
<DL>
<DD>the paths for  ephemeral session id
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>sessionId</CODE> - the session id for which paths match to
<DT><B>Returns:</B><DD>the paths for a session id</DL>
</DD>
</DL>
<HR>

<A NAME="setlastProcessedZxid(long)"><!-- --></A><H3>
setlastProcessedZxid</H3>
<PRE>
public void <B>setlastProcessedZxid</B>(long&nbsp;zxid)</PRE>
<DL>
<DD>the last processed zxid in the datatree
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>zxid</CODE> - the last processed zxid in the datatree</DL>
</DD>
</DL>
<HR>

<A NAME="processTxn(TxnHeader, org.apache.jute.Record)"><!-- --></A><H3>
processTxn</H3>
<PRE>
public <A HREF="../../../../org/apache/zookeeper/server/DataTree.ProcessTxnResult.html" title="class in org.apache.zookeeper.server">DataTree.ProcessTxnResult</A> <B>processTxn</B>(TxnHeader&nbsp;hdr,
                                            org.apache.jute.Record&nbsp;txn)</PRE>
<DL>
<DD>the process txn on the data
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>hdr</CODE> - the txnheader for the txn<DD><CODE>txn</CODE> - the transaction that needs to be processed
<DT><B>Returns:</B><DD>the result of processing the transaction on this
 datatree/zkdatabase</DL>
</DD>
</DL>
<HR>

<A NAME="statNode(java.lang.String, org.apache.zookeeper.server.ServerCnxn)"><!-- --></A><H3>
statNode</H3>
<PRE>
public Stat <B>statNode</B>(java.lang.String&nbsp;path,
                     <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A>&nbsp;serverCnxn)
              throws <A HREF="../../../../org/apache/zookeeper/KeeperException.NoNodeException.html" title="class in org.apache.zookeeper">KeeperException.NoNodeException</A></PRE>
<DL>
<DD>stat the path
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path for which stat is to be done<DD><CODE>serverCnxn</CODE> - the servercnxn attached to this request
<DT><B>Returns:</B><DD>the stat of this node
<DT><B>Throws:</B>
<DD><CODE>KeeperException.NoNodeException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="getNode(java.lang.String)"><!-- --></A><H3>
getNode</H3>
<PRE>
public <A HREF="../../../../org/apache/zookeeper/server/DataNode.html" title="class in org.apache.zookeeper.server">DataNode</A> <B>getNode</B>(java.lang.String&nbsp;path)</PRE>
<DL>
<DD>get the datanode for this path
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path to lookup
<DT><B>Returns:</B><DD>the datanode for getting the path</DL>
</DD>
</DL>
<HR>

<A NAME="convertLong(java.lang.Long)"><!-- --></A><H3>
convertLong</H3>
<PRE>
public java.util.List&lt;ACL&gt; <B>convertLong</B>(java.lang.Long&nbsp;aclL)</PRE>
<DL>
<DD>convert from long to the acl entry
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>aclL</CODE> - the long for which to get the acl
<DT><B>Returns:</B><DD>the acl corresponding to this long entry</DL>
</DD>
</DL>
<HR>

<A NAME="getData(java.lang.String, Stat, org.apache.zookeeper.Watcher)"><!-- --></A><H3>
getData</H3>
<PRE>
public byte[] <B>getData</B>(java.lang.String&nbsp;path,
                      Stat&nbsp;stat,
                      <A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)
               throws <A HREF="../../../../org/apache/zookeeper/KeeperException.NoNodeException.html" title="class in org.apache.zookeeper">KeeperException.NoNodeException</A></PRE>
<DL>
<DD>get data and stat for a path
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path being queried<DD><CODE>stat</CODE> - the stat for this path<DD><CODE>watcher</CODE> - the watcher function
<DT><B>Returns:</B><DD>
<DT><B>Throws:</B>
<DD><CODE>KeeperException.NoNodeException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="setWatches(long, java.util.List, java.util.List, java.util.List, org.apache.zookeeper.Watcher)"><!-- --></A><H3>
setWatches</H3>
<PRE>
public void <B>setWatches</B>(long&nbsp;relativeZxid,
                       java.util.List&lt;java.lang.String&gt;&nbsp;dataWatches,
                       java.util.List&lt;java.lang.String&gt;&nbsp;existWatches,
                       java.util.List&lt;java.lang.String&gt;&nbsp;childWatches,
                       <A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)</PRE>
<DL>
<DD>set watches on the datatree
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>relativeZxid</CODE> - the relative zxid that client has seen<DD><CODE>dataWatches</CODE> - the data watches the client wants to reset<DD><CODE>existWatches</CODE> - the exists watches the client wants to reset<DD><CODE>childWatches</CODE> - the child watches the client wants to reset<DD><CODE>watcher</CODE> - the watcher function</DL>
</DD>
</DL>
<HR>

<A NAME="getACL(java.lang.String, Stat)"><!-- --></A><H3>
getACL</H3>
<PRE>
public java.util.List&lt;ACL&gt; <B>getACL</B>(java.lang.String&nbsp;path,
                                  Stat&nbsp;stat)
                           throws <A HREF="../../../../org/apache/zookeeper/KeeperException.NoNodeException.html" title="class in org.apache.zookeeper">KeeperException.NoNodeException</A></PRE>
<DL>
<DD>get acl for a path
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path to query for acl<DD><CODE>stat</CODE> - the stat for the node
<DT><B>Returns:</B><DD>the acl list for this path
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../../org/apache/zookeeper/KeeperException.NoNodeException.html" title="class in org.apache.zookeeper">KeeperException.NoNodeException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="getChildren(java.lang.String, Stat, org.apache.zookeeper.Watcher)"><!-- --></A><H3>
getChildren</H3>
<PRE>
public java.util.List&lt;java.lang.String&gt; <B>getChildren</B>(java.lang.String&nbsp;path,
                                                    Stat&nbsp;stat,
                                                    <A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A>&nbsp;watcher)
                                             throws <A HREF="../../../../org/apache/zookeeper/KeeperException.NoNodeException.html" title="class in org.apache.zookeeper">KeeperException.NoNodeException</A></PRE>
<DL>
<DD>get children list for this path
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the path of the node<DD><CODE>stat</CODE> - the stat of the node<DD><CODE>watcher</CODE> - the watcher function for this path
<DT><B>Returns:</B><DD>the list of children for this path
<DT><B>Throws:</B>
<DD><CODE>KeeperException.NoNodeException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="isSpecialPath(java.lang.String)"><!-- --></A><H3>
isSpecialPath</H3>
<PRE>
public boolean <B>isSpecialPath</B>(java.lang.String&nbsp;path)</PRE>
<DL>
<DD>check if the path is special or not
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>path</CODE> - the input path
<DT><B>Returns:</B><DD>true if path is special and false if not</DL>
</DD>
</DL>
<HR>

<A NAME="getAclSize()"><!-- --></A><H3>
getAclSize</H3>
<PRE>
public int <B>getAclSize</B>()</PRE>
<DL>
<DD>get the acl size of the datatree
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the acl size of the datatree</DL>
</DD>
</DL>
<HR>

<A NAME="truncateLog(long)"><!-- --></A><H3>
truncateLog</H3>
<PRE>
public boolean <B>truncateLog</B>(long&nbsp;zxid)
                    throws java.io.IOException</PRE>
<DL>
<DD>Truncate the ZKDatabase to the specified zxid
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>zxid</CODE> - the zxid to truncate zk database to
<DT><B>Returns:</B><DD>true if the truncate is successful and false if not
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="deserializeSnapshot(org.apache.jute.InputArchive)"><!-- --></A><H3>
deserializeSnapshot</H3>
<PRE>
public void <B>deserializeSnapshot</B>(org.apache.jute.InputArchive&nbsp;ia)
                         throws java.io.IOException</PRE>
<DL>
<DD>deserialize a snapshot from an input archive
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>ia</CODE> - the input archive you want to deserialize from
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="serializeSnapshot(org.apache.jute.OutputArchive)"><!-- --></A><H3>
serializeSnapshot</H3>
<PRE>
public void <B>serializeSnapshot</B>(org.apache.jute.OutputArchive&nbsp;oa)
                       throws java.io.IOException,
                              java.lang.InterruptedException</PRE>
<DL>
<DD>serialize the snapshot
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>oa</CODE> - the output archive to which the snapshot needs to be serialized
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE>
<DD><CODE>java.lang.InterruptedException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="append(org.apache.zookeeper.server.Request)"><!-- --></A><H3>
append</H3>
<PRE>
public boolean <B>append</B>(<A HREF="../../../../org/apache/zookeeper/server/Request.html" title="class in org.apache.zookeeper.server">Request</A>&nbsp;si)
               throws java.io.IOException</PRE>
<DL>
<DD>append to the underlying transaction log
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>si</CODE> - the request to append
<DT><B>Returns:</B><DD>true if the append was succesfull and false if not
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="rollLog()"><!-- --></A><H3>
rollLog</H3>
<PRE>
public void <B>rollLog</B>()
             throws java.io.IOException</PRE>
<DL>
<DD>roll the underlying log
<P>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="commit()"><!-- --></A><H3>
commit</H3>
<PRE>
public void <B>commit</B>()
            throws java.io.IOException</PRE>
<DL>
<DD>commit to the underlying transaction log
<P>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="close()"><!-- --></A><H3>
close</H3>
<PRE>
public void <B>close</B>()
           throws java.io.IOException</PRE>
<DL>
<DD>close this database. free the resources
<P>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/WatchManager.html" title="class in org.apache.zookeeper.server"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/ZooKeeperSaslServer.html" title="class in org.apache.zookeeper.server"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?org/apache/zookeeper/server/ZKDatabase.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ZKDatabase.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
